#pragma once

#include "node.hpp"

#include "data/csv_dump.hpp"
#include "util/points.hpp"

#include <QList>
#include <QPair>
#include <QString>

namespace impl {
[[nodiscard]] Points
getNrBonusPoints(const QList<QPair<QString, Points>> &bonusPointList,
                 const QString &regNr) noexcept;
}

/**
 * \brief TODO
 */
struct BonusPoints : Node<> {
    using Node<>::Node;

    /**
     * \brief TODO
     */
    BonusPoints() = default;
    /**
     * \brief TODO
     */
    explicit BonusPoints(const CsvDump &c) noexcept(false);

    [[nodiscard]] Points getNrBonusPoints(const QString &regNr) const noexcept;

    QList<QPair<QString, Points>> mTotalBonusPointsPerStudent{};

    // A list of all students with invalid (non-numerical) registration numbers
    // and/or with invalid bonus point counts. If only the registration number
    // is non-numerical, then the student is in both this list and in the
    // regular list `mRegistrationNr`.
    // The first pair element is the registration number, the second element is
    // the bonus point count.
    QList<QPair<QString, QString>> mInvalidRegNrs{};

    // Store the entire csv dump so that we can more easily export it later
    CsvDump mBonusPoints;
};
