#include "input_window.hpp"

#include "view/main_window/main_window.hpp"

inline constexpr int csvTabIdx = 0;

InputWindow::InputWindow(const MainWindow &mainWindow, QWidget *parent)
    : QWidget(parent), mHandreichungLink(str::ui::input::guidelineHint),
      mLayout(this) {

    setWindowTitle(str::title::inputWindow);

    // Link to Handreichung
    mHandreichungLink.setTextFormat(Qt::RichText);
    mHandreichungLink.setOpenExternalLinks(true);
    mHandreichungLink.setTextInteractionFlags(Qt::TextBrowserInteraction);
    mHandreichungLink.setWordWrap(true);

    // Tab for every type of file import
    mTabs.addTab(&mInputCsvSingle, str::ui::input::csvTab);
    mTabs.addTab(&mInputD2R, str::ui::input::d2rTab);
    mTabs.setCurrentIndex(csvTabIdx);

    mLayout.addWidget(&mHandreichungLink);
    mLayout.addWidget(&mTabs);

    // Notify main window when a tab has imported input files
    connect(&mInputCsvSingle, &InputTabCsvSingleCohort::inputTabFilesImported,
            &mainWindow, &MainWindow::resetToInputFiles);
    connect(&mInputD2R, &InputTabD2R::inputTabFilesImported, &mainWindow,
            &MainWindow::resetToInputFiles);
    // add other tabs here once implemented
}
