#pragma once

#include <QList>
#include <QScrollArea>
#include <QSize>

struct FontSize;
class QGridLayout;
class QChart;

class TaskTab : public QScrollArea {
    Q_OBJECT

public:
    explicit TaskTab(QWidget *parent = nullptr);

    // Change the font size of the axis labels and potentially change the number
    // of axis labels
    void handleResize(QSize windowSize, FontSize largeFontSize);

public slots:
    /**
     * \brief Redraw all charts.
     */
    void pointsChanged();

private:
    void changeFontSize(FontSize largeFontSize);
    void correctAxisLabels(QSize windowSize, FontSize largeFontSize);

    QGridLayout *mLayout = nullptr;

    QList<QChart *> mPointCharts;
    QList<QChart *> mBoxCharts;
};
